﻿using dnlib.DotNet;
using HarmonyLib;

var defaultLazerPath = Environment.ExpandEnvironmentVariables(@"%LOCALAPPDATA%\osulazer");

if (!Directory.Exists(defaultLazerPath))
{
    Console.WriteLine("Please, drag & drop osu.Game.dll file.");
    Environment.Exit(1);
}

var osuPath = Directory.GetDirectories(defaultLazerPath).Last(f => f.Contains("app-"));

var osuPathDll = Path.Join(args.Length < 1 ? Path.Join(osuPath, "osu.Game.dll") : args[0]);

File.Copy(osuPathDll, osuPathDll + ".bak", true);
var modCtx = ModuleDef.CreateModuleContext();
var module = ModuleDefMD.Load(osuPathDll + ".bak", modCtx);

var typeDef = module.Find("osu.Game.Online.ProductionEndpointConfiguration", false);

var constructor = typeDef.FindConstructors().ElementAt(0);

var hostField = constructor.Body.Instructions[4];
var spectatorField = constructor.Body.Instructions[17];
var multiField = constructor.Body.Instructions[20];

spectatorField.Operand = "https://lazer.dhcpcd.xyz/spectator";
multiField.Operand = "https://lazer.dhcpcd.xyz/multiplayer";
hostField.Operand = "https://lazer.dhcpcd.xyz";


module.Write(osuPathDll);
Console.WriteLine("Done!~");
Console.WriteLine($"osu!lazer location: {Environment.ExpandEnvironmentVariables(@"%LOCALAPPDATA%\osulazer")}");
Console.WriteLine($"To reset client to bancho, replace osu.Game.dll with osu.Game.dll.bak");
Console.ReadLine();